算法题打卡day49-股票问题 | 121. 买卖股票的最佳时机、122.买卖股票的最佳时机II

121. 买卖股票的最佳时机 - 力扣(LeetCode)

状态:贪心AC。

先贴出贪心算法代码:

class Solution {
public:
    int maxProfit(vector<int>& prices) {
        int low = INT_MAX;
        int res = 0, len = prices.size();
        for(int i = 0; i < len; ++i){
            low = min(low, prices[i]);
            res = max(res, prices[i] - low);
        }
        return res;
    }
};

 动态规划的思路,在代码中体现:

class Solution {
public:
    int maxProfit(vector<int>& prices) {
        int len = prices.size();
        vector<vector<int>> dp(len, vector<int>(2, 0));
        //dp[i][0]表示第i天持有股票的最大收益,dp[i][1]表示不持有的最大收益
        dp[0][0] = -prices[0], dp[0][1] = 0;
        for(int i = 1; i < len; ++i){
            dp[i][0] = max(dp[i-1][0], -prices[i]);
            dp[i][1] = max(dp[i-1][1], dp[i-1][0]+prices[i]);
        }
        return dp[len-1][1];
    }
};

122. 买卖股票的最佳时机 II - 力扣(LeetCode)

状态:AC.

与第一题的唯一区别就在于转移方程中dp[i][0]的状态变化,也就是第i天持有股票的最大收益,因为第一题只能买一次,所以如果前一天不持有今天持有的话一定是-prices[i],但是这道题可以多次操作,所以前一天不持有今天持有的话应该是dp[i-1][1]-prices[i]。代码如下:

class Solution {
public:
    int maxProfit(vector<int>& prices) {
        int len = prices.size();
        vector<vector<int>> dp(len, vector<int>(2, 0));
        dp[0][0] = -prices[0], dp[0][1] = 0;
        for(int i = 1; i < len; ++i){
            dp[i][0] = max(dp[i-1][0], dp[i-1][1]-prices[i]);
            dp[i][1] = max(dp[i-1][1], dp[i-1][0]+prices[i]);
        }
        return dp[len-1][1];
    }
};

 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值